import { Component, OnInit } from '@angular/core';
import { ProcessesService } from 'src/app/services/processes.service';
import { InAppBrowser } from '@ionic-native/in-app-browser/ngx';
import { ActivatedRoute } from '@angular/router';
import { Event } from '../../../../models/event.model';
import { MenuController, ModalController, PopoverController } from '@ionic/angular';
import { momentG }  from 'src/plugin/momentG'
import { DiscartExpedientModalPage } from '../../discart-expedient-modal/discart-expedient-modal.page';
import { BookMeetingModalPage } from '../../expediente/book-meeting-modal/book-meeting-modal.page';
import { CreateProcessPage } from 'src/app/modals/create-process/create-process.page';
import { DelegarPage } from 'src/app/modals/delegar/delegar.page';
import { AddNotePage } from 'src/app/modals/add-note/add-note.page';
import { DespachosOptionsPage } from 'src/app/shared/popover/despachos-options/despachos-options.page';
import { ToastService } from 'src/app/services/toast.service';
import { DespachoService } from 'src/app/Rules/despacho.service'
import { Location } from '@angular/common'
import { fullTask } from 'src/app/models/dailyworktask.model';
import { Attachment, AttachmentList } from 'src/app/models/Excludetask';
import { PermissionService } from 'src/app/OtherService/permission.service';

@Component({
  selector: 'app-despacho',
  templateUrl: './despacho.page.html',
  styleUrls: ['./despacho.page.scss'],
})
export class DespachoPage implements OnInit {
  months = ["Janeiro", "Fevereiro", "Março", "Abril", "Maio", "Junho", "Julho", "Agosto", "Setembro", "Outubro", "Novembro", "Dezembro"];
  days = ["Domingo", "Segunda-feira", "Terça-feira", "Quarta-feira", "Quinta-feira", "Sexta-feira", "Sábado"];

  customDate:any;

  // task: customTask;
  task;

  attachments:any;
  fulltask: any;
  eventsList: Event[] = [];
  serialnumber: string;
  caller:string;
  profile: string;
  intervenientes: any;
  cc: any = [];

  constructor(private activateRoute: ActivatedRoute,
    private processes: ProcessesService,
    private iab: InAppBrowser,
    private menu: MenuController,
    private modalController: ModalController,
    public popoverController: PopoverController,
    private activatedRoute: ActivatedRoute,
    private toastService: ToastService,
    private despachoService: DespachoService,
    private location: Location,
    public p: PermissionService,
    

    ) {
    this.activatedRoute.paramMap.subscribe(params => {
      if(params["params"].SerialNumber) {
        this.serialnumber = params["params"].SerialNumber;
      }
      if(params["params"].caller) {
        this.caller = params["params"].caller;
      }
    });
  }

  ngOnInit() {
    this.profile = "mdgpr";
    this.activateRoute.paramMap.subscribe(paramMap => {
      if (!paramMap.has('SerialNumber')) {
        return;
      }
    });

    this.LoadTaskDetail(this.serialnumber)
  }

  close() {
    this.modalController.dismiss();
  }

  goBack() {

    //this.navigationService.back()
    this.location.back();

    // if(this.task.Status == "Pending" && this.caller == 'gabinete-digital'){
    //   if (window.innerWidth < 801) {
    //     this.router.navigate(['/home/gabinete-digital/pendentes']);
    //   }
    //   else {
    //     let navigationExtras: NavigationExtras = {
    //       queryParams: {
    //         "pendentes": true,
    //       }
    //     }
    //     this.router.navigate(['/home/gabinete-digital'], navigationExtras);
    //   }
    // }
    // else{
    //   if (window.innerWidth < 801) {
    //     this.router.navigate(['/home/gabinete-digital/despachos']);
    //   } else {
    //     let navigationExtras: NavigationExtras = {
    //       queryParams: {
    //         'despachos': true
    //       }
    //     }
    //     this.router.navigate(['/home/gabinete-digital'], navigationExtras);
    //   }
    // }
  }

  async LoadTaskDetail(serial: string) {
    this.processes.GetTask(serial).subscribe( (res: fullTask) => {
      this.task = {
        "SerialNumber": res.serialNumber,
        "Folio": res.workflowInstanceDataFields.Subject,
        "Senders": res.originator.email,
        "CreateDate": momentG(new Date(res.taskStartDate),'yyyy-MM-dd HH:mm:ss'),
        "DocumentURL": res.workflowInstanceDataFields.ViewerRequest,
        "Remetente": res.workflowInstanceDataFields.Sender,
        "Note": res.workflowInstanceDataFields.TaskMessage || res.workflowInstanceDataFields.Note,
        "FolderID": res.workflowInstanceDataFields.FolderID,
        "FsId": '361',
        "DocId": res.workflowInstanceDataFields.DispatchDocId,
        "DocumentsQty": '',
        "WorkflowName": res.workflowDisplayName,
        "DeadlineType": res.workflowInstanceDataFields.DeadlineType,
        "activityInstanceName": res.activityInstanceName,
        "Status": res.workflowInstanceDataFields.Status,
      }
      this.fulltask = res;

      let thedate = new Date(this.task.CreateDate);
      this.customDate = this.days[thedate.getDay()]+ ", "  + thedate.getDate() +" de "  + ( this.months[thedate.getMonth()]);

      this.processes.GetTaskParticipants(this.task.FolderID).subscribe(users=>{

        this.intervenientes = users.filter(user=>{
          return user.Type == 'I';
        });
        this.cc = users.filter(user=>{
          return user.Type == 'CC';
        });
      });
    }, (error)=>{
      try {
        this.goBack()
      } catch (e) {
        this.location.back();
      } finally {
        if(error.status ==  0) {
          this.toastService.badRequest('Não é possível  visualizar este processo no modo offline')
        } else {
          this.toastService.badRequest('Processo não encontrado')
        }
      }
    });
  }

  viewDocument(docId:string){
    this.processes.GetDocumentUrl(docId, '361').subscribe(res=>{
      const url: string = res.replace("webTRIX.Viewer","webTRIX.Viewer.Branch1");
      const browser = this.iab.create(url,"_blank");
      browser.show();
    });
  }

  openMenu() {
    this.menu.open();
    this.modalController.dismiss();
  }

  async executado(note:string, documents:any) {

    const loader = this.toastService.loading()

    try {
      await this.despachoService.executado(note, documents, this.serialnumber).toPromise();
      this.toastService.successMessage('Processo criado')
      this.close();
    } catch(error) {
      this.toastService.badRequest("Processo não criado")
    }
    finally {
      loader.remove()
    }
  }

  async arquivar(note:string, documents: AttachmentList) {

    const loader = this.toastService.loading()

    try {
      await this.despachoService.arquivar(note, documents,this.serialnumber).toPromise()
      this.toastService.successMessage('Processo descartado')
      this.close();
    } catch (error) {
      this.toastService.badRequest("Processo não descartado")
    }
    finally {
      loader.remove()
    }

  }

  async reexecute(note:string, documents:any) {
    let body = {
      "serialNumber": this.serialnumber,
      "action": "Reexecução",
      "ActionTypeId": 100000010,
      "dataFields": {
        "ReviewUserComment": note,
      },
      "AttachmentList" :documents,
    }

    const loader = this.toastService.loading()

    try {
      await this.processes.CompleteTask(body).toPromise()
      this.toastService.successMessage()
      this.close();

    } catch (error) {
      this.toastService.badRequest()
    }
    finally {
      loader.remove()
    }

  }

  toDateString(e) {
    return new Date(e).toDateString()
  }

  async sendExpedienteToPending() {

    this.despachoService.sendExpedienteToPending(this.serialnumber).subscribe(res=>{
      this.goBack();
      this.toastService.successMessage()
    },
    error => {
      this.toastService.badRequest("Processo não enviado para despacho")
    });

  }

  async openAddNoteModal(actionName:string) {
    let classs;
    if( window.innerWidth <= 800){
      classs = 'modal modal-desktop'
    } else  {
      classs = 'add-note-modal-no-height'
    }
    const modal = await this.modalController.create({
      component: AddNotePage,
      componentProps:{
        showAttachmentBtn: true,
      },
      cssClass: classs,
      backdropDismiss: true
    });

    await modal.present();

    modal.onDidDismiss().then( async (res) => {
      if(res.data){

        const DocumentToSave = res.data.documents.map((e) => {
          return {
            ApplicationId: e.ApplicationType,
            SourceId: e.Id,
          }
        });

        let docs = {
          ProcessInstanceID: "",
          Attachments: DocumentToSave,
        }

        if(actionName == 'Executado'){

          await this.executado(res.data.note, docs);
          this.goBack();
        }
        else if(actionName == 'Arquivar'){
          await this.arquivar(res.data.note, docs);
          this.goBack();
        }
        else if(actionName == 'Reexecução'){
          await this.reexecute(res.data.note, docs);
          this.goBack();
        }
      }
    });
  }

  async openExpedientActionsModal(taskAction: any, task: any) {

    let classs;
    if( window.innerWidth <= 800) {
      classs = 'modal modal-desktop'
    } else  {
      classs = 'modal modal-desktop showAsideOptions'
    }
    const modal = await this.modalController.create({
      component: CreateProcessPage,
      componentProps: {
        taskAction: taskAction,
        task: task,
        profile: this.profile,
        fulltask: this.fulltask
      },
      cssClass: classs,
    });
    await modal.present();
    modal.onDidDismiss().then( async (res)=>{
      console.log(res['data']);

      if(res['data']=='openDiscart'){
        await this.distartExpedientModal();
      }

      this.goBack();
    });
  }

  async openBookMeetingModal(task: any) {
    let classs;
    if( window.innerWidth <= 800){
      classs = 'book-meeting-modal modal modal-desktop'
    } else  {
      classs = 'modal modal-desktop showAsideOptions'
    }
    const modal = await this.modalController.create({
      component: BookMeetingModalPage,
      componentProps: {
        task: this.task,
      },
      cssClass: classs,
      backdropDismiss: false
    });
    await modal.present();
    modal.onDidDismiss();
  }

  async openDelegarModal(task: any) {
    let classs;
    if( window.innerWidth <= 800){
      classs = 'book-meeting-modal modal modal-desktop'
    } else  {
      classs = 'modal modal-desktop showAsideOptions'
    }
    const modal = await this.modalController.create({
      component: DelegarPage,
      componentProps: {
        task: this.task,
      },
      cssClass: classs,
      backdropDismiss: false
    });
    await modal.present();
    modal.onDidDismiss().then(res=>{
      this.goBack();
    });
  }

  async distartExpedientModal() {
    console.log(this.fulltask);
    const modal = await this.modalController.create({
      component: DiscartExpedientModalPage,
       componentProps: {
        serialNumber: this.fulltask.serialNumber,
        folderId: this.fulltask.workflowInstanceDataFields.FolderID,
        action: 'complete',
      },
      cssClass: 'discart-expedient-modal',
      backdropDismiss: false
    });

    await modal.present();
    modal.onDidDismiss().then(res=>{
      if(res['data']=='close'){
        this.close();
        /* console.log('2Expedient Discard closed2');
        this.close();
        this.openMenu(); */
      }

    });
  }

  async openOptions(taskAction?: any) {

    const popover = await this.popoverController.create({
      component: DespachosOptionsPage,
      cssClass: 'exp-options',
      componentProps: {
        task: this.task,
        fulltask: this.fulltask,
        taskAction: taskAction,
        showEnviarPendentes: false
      },
      translucent: true
    });
    return await popover.present();
  }

}
